Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES > Class Template Reference

Defines a abstraction which will purge entries from a map. The map considered is the ACE_Hash_Map_Manager_Ex. More...

`#include <Hash_Cache_Map_Manager_T.h>`

Inheritance diagram for ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >:

[legend]
Collaboration diagram for ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >:

[legend]
List of all members.

## Public Types
typedef ACE_Pair< VALUE, ATTRIBUTES > | CACHE_VALUE
typedef ACE_Hash_Map_Manager_Ex< KEY, CACHE_VALUE, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex > | HASH_MAP
typedef ACE_Hash_Map_Entry< KEY, CACHE_VALUE > | CACHE_ENTRY
typedef KEY | key_type
typedef VALUE | mapped_type
## Public Methods
| ACE_Hash_Cache_Map_Manager (CACHING_STRATEGY &caching_s, size_t size=ACE_DEFAULT_MAP_SIZE, ACE_Allocator *alloc=0)
| Initialize a <Hash_Cache_Map_Manager> with <size> entries.
| ~ACE_Hash_Cache_Map_Manager (void)
int | bind (const KEY &key, const VALUE &value)
int | bind (const KEY &key, const VALUE &value, CACHE_ENTRY *&entry)
int | find (const KEY &key, VALUE &value)
| Loopkup entry<key,value> in the cache.
int | find (const KEY &key)
| Is <key> in the cache?
int | find (const KEY &key, CACHE_ENTRY *&entry)
| Obtain the entry when the find succeeds.
int | rebind (const KEY &key, const VALUE &value)
int | rebind (const KEY &key, const VALUE &value, VALUE &old_value)
int | rebind (const KEY &key, const VALUE &value, KEY &old_key, VALUE &old_value)
int | rebind (const KEY &key, const VALUE &value, CACHE_ENTRY *&entry)
int | trybind (const KEY &key, VALUE &value)
int | trybind (const KEY &key, VALUE &value, CACHE_ENTRY *&entry)
int | unbind (const KEY &key)
| Remove <key> from the cache.
int | unbind (const KEY &key, VALUE &value)
int | unbind (CACHE_ENTRY *entry)
| Remove entry from map.
## Protected Types
typedef ACMM< KEY, VALUE, ACE_Hash_Map_Manager_Ex< KEY, ACE_Pair< VALUE, ATTRIBUTES >, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex >, ACE_Hash_Map_Iterator_Ex< KEY, ACE_Pair< VALUE, ATTRIBUTES >, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex >, ACE_Hash_Map_Reverse_Iterator_Ex< KEY, ACE_Pair< VALUE, ATTRIBUTES >, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex >, CACHING_STRATEGY, ATTRIBUTES > | ACE_HCMM_BASE
| Base class.

## Detailed Description

### template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
class ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >

Defines a abstraction which will purge entries from a map. The map considered is the ACE_Hash_Map_Manager_Ex.

The Hash_Cache_Map_Manager will manage the map it contains and provide purging on demand from the map. The strategy for caching is decided by the user and provided to the Cache Manager. The Cache Manager acts as a agent and communicates between the Map and the Strategy for purging entries from the map. To tap the optimal methods like find(key,value,entry) present in the ACE_Hash_Map_Manager, Hash_Cache_Map_Manager provides extra functionality on top of the Cache_Map_Manager. No locking mechanism provided since locking at this level isnt efficient. Locking has to be provided by the application.

## Member Typedef Documentation

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
typedef ACMM<KEY, VALUE, ACE_Hash_Map_Manager_Ex<KEY, ACE_Pair<VALUE, ATTRIBUTES>, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex>, ACE_Hash_Map_Iterator_Ex<KEY, ACE_Pair<VALUE, ATTRIBUTES>, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex>, ACE_Hash_Map_Reverse_Iterator_Ex<KEY, ACE_Pair<VALUE, ATTRIBUTES>, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex>, CACHING_STRATEGY, ATTRIBUTES> ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::ACE_HCMM_BASE`[protected]`

| Base class.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
typedef ACE_Hash_Map_Entry<KEY, CACHE_VALUE> ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::CACHE_ENTRY

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
typedef ACE_Pair<VALUE, ATTRIBUTES> ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::CACHE_VALUE

| The actual value mapped to the key in the map. The <attributes> are used by the strategy and is transparent to the user of this class.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
typedef ACE_Hash_Map_Manager_Ex<KEY, CACHE_VALUE, HASH_KEY, COMPARE_KEYS, ACE_Null_Mutex> ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::HASH_MAP

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
typedef KEY ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::key_type

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
typedef VALUE ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::mapped_type

## Constructor & Destructor Documentation

template<T_1 >
ACE_Hash_Cache_Map_Manager<>::ACE_Hash_Cache_Map_Manager | ( | CACHING_STRATEGY & | caching_s,
|  | size_t | size = ACE_DEFAULT_MAP_SIZE,
|  | ACE_Allocator * | alloc = 0
| ) |

| Initialize a <Hash_Cache_Map_Manager> with <size> entries.

template<T_1 >
ACE_Hash_Cache_Map_Manager<>::~ACE_Hash_Cache_Map_Manager | ( | void |  | ) |

| Close down a <Cache_Map_Manager> and release dynamically allocated resources.

## Member Function Documentation

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::bind | ( | const KEY & | key,
|  | const VALUE & | value,
|  | CACHE_ENTRY *& | entry
| ) |

| Same as a normal bind, except the cache entry is also passed back to the caller. The entry in this case will either be the newly created entry, or the existing one.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::bind | ( | const KEY & | key,
|  | const VALUE & | value
| ) |

| Associate <key> with <value>. If <key> is already in the MAP then the ENTRY is not changed. Returns 0 if a new entry is bound successfully, returns 1 if an attempt is made to bind an existing entry, and returns -1 if failures occur.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::find | ( | const KEY & | key,
|  | CACHE_ENTRY *& | entry
| ) |

| Obtain the entry when the find succeeds.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::find | ( | const KEY & | key | ) |

| Is <key> in the cache?

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::find | ( | const KEY & | key,
|  | VALUE & | value
| ) |

| Loopkup entry<key,value> in the cache.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::rebind | ( | const KEY & | key,
|  | const VALUE & | value,
|  | CACHE_ENTRY *& | entry
| ) |

| Same as a normal rebind, except the cache entry is also passed back to the caller. The entry in this case will either be the newly created entry, or the existing one.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::rebind | ( | const KEY & | key,
|  | const VALUE & | value,
|  | KEY & | old_key,
|  | VALUE & | old_value
| ) |

| Reassociate <key> with <value>, storing the old key and value into the "out" parameters <old_key> and <old_value>. The function fails if <key> is not in the cache for caches that do not allow user specified keys. However, for caches that allow user specified keys, if the key is not in the cache, a new <key>/<value> association is created.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::rebind | ( | const KEY & | key,
|  | const VALUE & | value,
|  | VALUE & | old_value
| ) |

| Reassociate <key> with <value>, storing the old value into the "out" parameter <old_value>. The function fails if <key> is not in the cache for caches that do not allow user specified keys. However, for caches that allow user specified keys, if the key is not in the cache, a new <key>/<value> association is created.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::rebind | ( | const KEY & | key,
|  | const VALUE & | value
| ) |

| Reassociate the <key> with <value>. If the <key> already exists in the cache then returns 1, on a new bind returns 0 and returns -1 in case of any failures.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::trybind | ( | const KEY & | key,
|  | VALUE & | value,
|  | CACHE_ENTRY *& | entry
| ) |

| Same as a normal trybind, except the cache entry is also passed back to the caller. The entry in this case will either be the newly created entry, or the existing one.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::trybind | ( | const KEY & | key,
|  | VALUE & | value
| ) |

| Associate <key> with <value> if and only if <key> is not in the cache. If <key> is already in the cache, then the <value> parameter is overwritten with the existing value in the cache. Returns 0 if a new <key>/<value> association is created. Returns 1 if an attempt is made to bind an existing entry. This function fails for maps that do not allow user specified keys.

template<T_1 >
int ACE_Hash_Cache_Map_Manager<>::unbind | ( | CACHE_ENTRY * | entry | ) |

| Remove entry from map.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::unbind | ( | const KEY & | key,
|  | VALUE & | value
| ) |

| Remove <key> from the cache, and return the <value> associated with <key>.

template<class KEY, class VALUE, class HASH_KEY, class COMPARE_KEYS, class CACHING_STRATEGY, class ATTRIBUTES>
int ACE_Hash_Cache_Map_Manager< KEY, VALUE, HASH_KEY, COMPARE_KEYS, CACHING_STRATEGY, ATTRIBUTES >::unbind | ( | const KEY & | key | ) |

| Remove <key> from the cache.

The documentation for this class was generated from the following files:

- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Hash_Cache_Map_Manager_T.h
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/Hash_Cache_Map_Manager_T.cpp